#' ---
#' title: |
#'   医薬品開発のための統計解析 第3部2章1節 \
#'   誤差を考慮した解析 \
#'   Green3-2-1b.R
#' author: "Masahiko Katase"
#' date: "2021/3/15"
#' ---

library(readxl)

df <- read_excel("Green3-2.xlsx", sheet = "21-futoubunsan2")
df <- data.frame(df)

#'# 表示2.1.9 データと散布図（p.76）
plot(y ~ x, data = df, xlim = c(0, 5))

#'# 表示2.1.10 yi-hat とeij の関係(p.76)
df1 <- aggregate(df[2], df[1], FUN = mean)
colnames(df1) <- c("x","ybar")
df2 <- merge(df1, df, all = TRUE)
df2$e <- abs(df2$y - df2$ybar)
df2$sqry <- df2$ybar^0.5
lm_out <- lm(df2$e ~ df2$sqry + 0)
b <- lm_out$coefficients[1]
x <- seq(0, 10, length = 100)
y <- b * x^0.5
  
plot(x = df2$ybar, y = df2$e, xlim = c(0, 10), ylim = c(0, 3))
lines(x, y, col = 2)
abline(lm(df2$e ~ df2$ybar + 0))

#'# 表示2.1.11 べき数 p の推定(p.77)
nls.out <- nls(formula = e ~ b * ybar ^ p, 
               start = list(b = 0.4,
                            p = 0.5),
                data = df2) 
summary(nls.out)