#' ---
#' title: |
#'   医薬品開発のための統計解析 第3部2章3節 \
#'   併用効果（相乗・拮抗） \
#'   Green3-2-3c.R
#' author: "Masahiko Katase"
#' date: "2021/3/25"
#' ---

library(readxl)

df <- read_excel("Green3-2.xlsx", sheet = "en23-3")
df <- data.frame(df)

#'# 表示2.7.2 個々の値の解析結果（p.134）
mdl <- y ~ ifelse(t == "single",
       y0 * (1 - ((x1 + cc * x2)^b / ((x1 + cc * x2)^b + x50^b))),
       y0 * (1 - (((x1 + cc * x2) / ci)^b / (((x1 + cc * x2) / ci)^b + x50^b)))
)

nls_out <- nls(formula = mdl, 
               start = list(y0 = 120, b = 2, x50 = 2, cc = 0.655, ci = 1),
               data = df)

print(nls_out)　　　　　　 # 結果の要約 
summary(nls_out)           # 推定値、近似標準誤差、t値
confint(nls_out)           # 区間推定
cov2cor(vcov(nls_out))     # 推定値の相関

cbind(df, "y-hat" = predict(nls_out), "e" = df$y - predict(nls_out))
